unit misc;

interface

uses def;

procedure WaitRetrace;
{procedure WaitForKey;}
procedure Error(error_code: word);
procedure MemCopy(var source, dest; count: word);
procedure MemCopyDword(var source, dest; count: word);

implementation

{}

{ procedura ceka na vertikalni retrace }
procedure WaitRetrace; assembler;
asm
    mov dx,3DAh
@@l1:
    in al,dx
    and al,08h
    jnz @@l1
@@l2:
    in al,dx
    and al,08h
    jz  @@l2
end;


{}

{procedure WaitForKey; assembler;
asm
   xor ah, ah
   int 16h
end;}


{}

procedure error(error_code: word);
begin
  case error_code of
    ERR_UNKNOWN         : writeln('Error: Unknown error');
    ERR_FILE_NOT_FOUND  : writeln('Error: File not found');
    ERR_INV_SIZE        : writeln('Error: Invalid bitmap size');
    ERR_NOT_BMP         : writeln('Error: Not a bitmap file');
    ERR_INV_HW          : writeln('Error: Invalid height/width');
    ERR_BI_RLE          : writeln('Error: BI_RLE compression not supported');
    ERR_NOT_256         : writeln('Error: Only 256 color bitmaps supported');
    ERR_NO_PARAMS       : writeln('Error: No parameters on command line');
    ERR_TOO_MANY_PARAMS : writeln('Error: Too many parameters');
    ERR_CANT_WRITE      : writeln('Error: Could not write file');
    ERR_NOT_PCX         : writeln('Error: Not a valid PCX file');
    ERR_PCX_PAL         : writeln('Error: PCX palette corrupt');
    ERR_NOT_FONT        : writeln('Error: Not a valid font file');
    ERR_NOT_ENOUGH_MEM  : writeln('Error: Not enough memory');
    ERR_NOT_SPRITE      : writeln('Error: Not a sprite file');
  else writeln ('Unhandled error');
  end;
  halt(1);
end;


{}

procedure MemCopy(var source, dest; count: word); assembler;
asm
  mov  dx, ds
  cld
  mov  ds, ss:[bp+14]
  mov  si, ss:[bp+12]
  mov  es, ss:[bp+10]
  mov  di, ss:[bp+8]
  mov  cx, ss:[bp+6]
  mov  ax, cx
  shr  cx, 2
  db 0f3h, 66h, 0a5h {rep  movsd}
  mov  cx, ax
  and  cx, 3
  rep  movsb
  mov  ds, dx
@end:
end;


{}

procedure MemCopyDword(var source, dest; count: word); assembler;
asm
  mov  cx, ss:[bp+6]
  mov  ds, ss:[bp+14]
  mov  si, ss:[bp+12]
  mov  es, ss:[bp+10]
  mov  di, ss:[bp+8]
  shr  cx, 2
  db 0f3h, 66h, 0a5h {rep  movsd}
  mov  ds, dx
end;

{}

end.

